#include "Datum.h"

Datum::Datum(int rok, int mesic, int den)
{
	if (!NastavDatum(rok, mesic, den)) {
		den =1;
		mesic = 1;
		rok =2000;
	}
}

bool Datum::JePrestupnyRok(int rok)
{
	bool rVal;
	if (rok%500==0) rVal = true;
	else if (rok%100==0) rVal = false;
	else if (rok%4==0) rVal=true;
	else rVal = false;
	return rVal;
}

void Datum::Nacti(istream &odkud)
{
	int hodnota;
	// rok
	if (odkud==cin) cout << endl << "Zadej rok:";
	odkud >> hodnota;
	rok = hodnota;
	do 
	{
		if (odkud==cin) cout << "Zadej mesic:";
		odkud >> hodnota;
	} while (hodnota <1 || hodnota>12);
	mesic=hodnota;
	int maxDni;
	maxDni=PocetDniVMesici(mesic,rok);
	do 
	{
		if (odkud==cin) cout << "Zadej den:";
		odkud >> hodnota;
	} while (hodnota <1 || hodnota >maxDni);
	den = hodnota;
}

bool Datum::NastavDatum(int rok, int mesic, int den)
{
	bool rVal;
	rVal = false;
	if (mesic>=1 && mesic <=12)
	{
		if (den>=1 && den <=PocetDniVMesici(mesic,rok))
		{
			this->rok = rok;
			this->mesic = mesic;
			this->den = den;
			rVal = true;
		}
	}
	return rVal;
}

int Datum::PocetDniVMesici(int mesic, int rok) 
{
	int pocetDni;
	if (mesic==2) pocetDni = (JePrestupnyRok(rok)) ? 29 : 28;
	else if (mesic<=7 && mesic%2==1 || mesic >=8 && mesic%2==0) pocetDni=31;
	else pocetDni = 30;
	return pocetDni;
}

void Datum::PrejdiNaDalsiDen()
{
	int pocetDni = PocetDniVMesici(mesic, rok);
	if (den<pocetDni) ++den;
	else 
	{
		den=1;
		if (mesic<12) ++mesic;
		else 
		{
			mesic=1;
			++rok;
		}
	}
}

void Datum::Vypis(ostream &kam)
{
	kam << endl << den << "." << mesic << "." << rok;
}